import cgi
import os
import smtplib
import fcntl
import sha
import re
from string import atoi
from email.MIMEText import MIMEText

def ordinal(n):
   if n == 1:
      return str(n) + 'st'
   if n == 2:
      return str(n) + 'nd'
   if n == 3:
      return str(n) + 'rd'
   if n < 20:
      return str(n) + 'th'
   return ordinal(n % 10)

def main():

    try:
        handle=open('votes/lock')
        fcntl.flock(handle.fileno(),fcntl.LOCK_EX)
    except:
        printHeader()
        printBusy()
        printFooter()
        return

    try:
        address = os.environ['SSL_CLIENT_S_DN_Email']
    except:
        printHeader()
        printError()
        printFooter()
        return

    form = cgi.FieldStorage()
    ballot = []
    i = 0 
    while True:
       try:
          ballot.append(int(form['rank-%d' % i].value))
       except KeyError:
          break
       i += 1

    if i != 5:
        printHeader()
        printError(address)
        printFooter()
        return

#    for j in range(i):
#        if not j+1 in ballot:
#            printHeader()
#            printRanking()
#            printFooter()
#            return


    printHeader()

    if ('\n'+address) in file('votes/VOTED').read():
       printVoted(address)
    elif not ('\n'+address) in file('MEMBERS').read():
       printNotRegistered(address)
    else:
       voted_list = file('votes/VOTED').readlines()
       voted_list.append(address)
       voted_list.sort()
       VOTED = '\n'
       for i in voted_list:
           i = i.strip()
           if i != '':
               VOTED += ('%s\n' % i)

       file('votes/VOTED','w').write(VOTED)

       time = os.popen('date "+%y/%m/%d %H:%M:%S"').read()

       file('votes/BALLOTS','a').write('%r %s\n' % (ballot,time))

       notify_success(address,ballot)
       
       printSuccess(address)

    printFooter()

def notify_success(address,ballot):

    candidates = file('CANDIDATES').readlines()
    n = len(candidates)
    sheet = []
    for i in range(n):
        sheet.append(ordinal(ballot[i])+' choice) '+candidates[i])
    sheet.sort()
    votelist = ''
    for line in sheet:
        votelist += line
    
    fromaddr = 'rocsa-officers@mit.edu'
    toaddr = address
    body = '''
This message confirms that %s has cast a vote. The vote was recorded as 

%s

If this is not the case, please notify the committee immediately.

The 40-character code at the end of this email is a security feature. You may go to http://scripts.mit.edu/~chiao/checkvote.html to verify the authenticity of this email.

Thank you for voting.

ROCSA Committee

''' % (address,votelist.strip())

    chksum=sha.new('Taiwan stands proud! Randomness makes for a good passphrase.')
    newbody = body
    newbody = re.sub('\s','',newbody)
    chksum.update(newbody)
    
    msg = MIMEText(body+chksum.hexdigest())
    msg['From'] = fromaddr
    msg['To'] = toaddr
    msg['Subject'] = 'MIT ROCSA Ballot Confirmation'

    server = smtplib.SMTP('outgoing.mit.edu')
    server.sendmail(fromaddr,toaddr,msg.as_string())
    server.quit()

def printVoted(address):
    print '''<p> Error! %s has already voted! You can only vote once! </p>''' % address

def printBusy():
    print '''<p> Error! Someone else was voting at the same time, please try again! </p>'''

def printError(address=None):
    if address != None:
        address = os.environ['REMOTE_ADDR']
    if not ('\n'+address+'\n') in file('votes/SUSPECTS').read():
        file('votes/SUSPECTS','a').write(address+'\n')
    print '''<p> Error! Please try again! </p>'''

def printRanking():
    print '''<p> Error! No two names can have the same ranking, please try again! </p>'''

def printNotRegistered(address):
    print '''<p> Error! %s was not registered to vote! </p>''' % address

def printHeader():
    print '''Content-Type: text/html

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
   <head>
      <meta http-equiv="Content-Type" content="text/html;charset=us-ascii" />
      <link rel="stylesheet" type="text/css" href="../****/style.css"/>
      <title>Vote Submission</title>
   </head>
   <body>'''

def printSuccess(address):
    print '''
      <p>Thank you for voting. A confirmation email has been sent to %s </p>
      <p>Click <a href="http://web.mit.edu/ROCSA/www/">here</a> to return to the website.</p>''' % address

def printFooter():
    print '''
   </body>
</html>'''

main()

