#!/usr/bin/env python
import re

def main():
    
    print '''Content-Type: text/html

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
   <head>
      <meta http-equiv="Content-Type" content="text/html;charset=us-ascii" />
      <link rel="stylesheet" type="text/css" href="../****/style.css"/>
      <title>Registration Progress</title>
   </head>
   <body>'''
    print "<PRE>"
    printAnalysis()
    print "</PRE>"
    print '''
   </body>
</html>''' 

def cmp(a,b):
    l = [a,b]
    for i in range(2):
        name = l[i]
        if not ',' in name:
            name = name.split('|')
            ln = name[0].split()[-1].strip()
            fn = name[0].strip()[:-len(ln)].strip()
            l[i] = ln+', '+fn+'  |'+name[1]
    a,b = l
    if a.strip() < b.strip():
        return -1
    else:
        return 1

def printlist(list):
    for line in list:
        print line

def printAnalysis():
    data = open('address_book.csv').readlines()
    names = {}
    active = []
    for line in data[1:]:
        line = line.split(',')
        email = line[5]
        if email:
            email = re.sub('@mit.edu','@MIT.EDU',email)
            active.append(email)
            names[email] = line[1].strip('"')

    valid = []
    invalid = []
    for email in active:
        if re.search('@MIT.EDU',email):
            valid.append(email)
        else:
            invalid.append(email)

    registered = []
    data = open('votes/REGISTER').readlines()
    regnames = {}
    for line in data:
        line = line.split('|')
        email = line[1].strip()
        registered.append(email)
        regnames[email] = line[0].strip()

    valid_registered = []
    valid_notregistered = []
    
    for email in valid:
        if email in registered:
            valid_registered.append(email)
        else:
            valid_notregistered.append(email)
        
    registered_inactive = []
    for email in registered:
        if not email in valid:
            registered_inactive.append(email)
        
    print "Active and Registered:"
    list = []
#    members = file('MEMBERS_pre','w')
    for email in valid_registered:
        entry = "%30s  |  %s" % (regnames[email],email[:-8])
        list.append(entry)
#        members.write('\n'+email)
#    members.close()
    list.sort(cmp); printlist(list)
    print "%30s  :  %s" % ('No. of people',len(valid_registered))
    print
    print "Active and Not Registered:"
    list = []
    for email in valid_notregistered:
        entry = "%30s  |  %s" % (names[email],email[:-8])
        list.append(entry)
    list.sort(cmp); printlist(list)
    print "%30s  :  %s" % ('No. of people',len(valid_notregistered))
    print
    print "Registered but Not Active:"
    list = []
    for email in registered_inactive:
        entry = "%30s  |  %s" % (regnames[email],email[:-8])
        list.append(entry)
    list.sort(cmp); printlist(list)
    print "%30s  :  %s" % ('No. of people',len(registered_inactive))
    print
    print "Active but Invalid email:"
    list = []
    for email in invalid:
        entry = "%30s  |  %s" % (names[email],email)
        list.append(entry)
    list.sort(cmp); printlist(list)
    print "%30s  :  %s" % ('No. of people',len(invalid))

main()
