#!/usr/bin/python

import fcntl, os

def main():
    try:
        handle=open('votes/lock')
        fcntl.flock(handle.fileno(),fcntl.LOCK_EX)
    except:
        printHeader()
        printBusy()
        printFooter()
        return

    printHeader()
    try:
        address = os.environ['SSL_CLIENT_S_DN_Email']
    except:
        printError('Use https instead of http! Also make sure you have web certificates working!')
        printFooter
        return
    name = os.environ['SSL_CLIENT_S_DN_CN']

    record = "%30s  |  %s\n" % (name,address)
    if "|  %s\n" % (address) in file('votes/REGISTER').read():
        printWasRecorded(address)
    else:
        file('votes/REGISTER','a').write(record)
        printRecorded(address)
    printFooter()        

def printRecorded(address):
    print '''<p> %s has been registered successfully! </p>''' % address

def printWasRecorded(address):
    print '''<p> Our records show that %s is already registered to vote! </p>''' % address

def printHeader():
    print '''Content-Type: text/html

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
   <head>
      <meta http-equiv="Content-Type" content="text/html;charset=us-ascii" />
      <link rel="stylesheet" type="text/css" href="../****/style.css"/>
      <title>Registration to Vote</title>
   </head>
   <body>'''

def printFooter():
    print '''
   </body>
</html>'''

def printBusy():
    print '''<p> Error! Someone else was registering at the same time, please try again! </p>'''

def printError(message):
    print '      <p>%s</p>\n' % message

main()
